
#include <iostream>
#include <vector>

#include "ploughshare/ploughshare.h"
#include "appl_grid/appl_grid.h"



template<typename T>
inline std::ostream& operator<<( std::ostream& s, const std::vector<T>& v ) { 
  for ( size_t i=0 ; i<v.size() ; i++ ) s << "\n\t" << v[i];
  return s;
} 


template<typename T>
inline std::ostream& operator<<( std::ostream& s, const std::set<T>& v ) { 
  for ( auto it=v.begin() ; it!=v.end() ; it++ ) s << "\n\t" << *it;
  return s;
} 



template<typename T, typename U>
inline std::ostream& operator<<( std::ostream& s, const std::map<T,U>& v ) { 
  for ( auto it=v.begin() ; it!=v.end() ; it++ ) s << "\n\t" << it->first << "\n\t" << it->second;
  return s;
} 


template<typename T, typename U>
inline std::ostream& operator<<( std::ostream& s, const std::map<T,const U>& v ) { 
  for ( auto it=v.begin() ; it!=v.end() ; it++ ) s << "\n\t" << it->first << "\t" << it->second;
  return s;
} 



int main() { 
   
   ploughshare p; 

   p.verbose(true);

   std::cout << "path: " << p.path() << std::endl;

   p.fetch( "atlas-atlas-z0-arxiv-1612.03016" );

   std::cout << "dataset path:  " <<  p.path("atlas-atlas-z0-arxiv-1612.03016")  << std::endl;
   std::cout << "dataset grids: " << p.grids("atlas-atlas-z0-arxiv-1612.03016") << std::endl;

   std::vector<std::string> grids = p.grids("atlas-atlas-z0-arxiv-1612.03016" );

   for ( size_t i=0 ; i<grids.size() ; i++ ) { 
    
      appl::grid g(grids[i]);

   }

   return 0;
}


